print("Mario Bros Tweaks Loading.")

--Making a console variable to enable or disable ring drain
local allowRingDrain = CV_RegisterVar({
	name = "tu_mariobrosringdrain",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

--I fucking hate this
--Make empty variables we'll use later
local isItABro = {}
local ringDrainShields = {}

--variables we don't have to redefine on player join
local defaultMiniTics = 1 * TICRATE

--I have to do this shit every time a player joins to stop resyncs
local function defineKeyData()
--this disables Kuribo's shoe
if MARIOSHIELDS then
	MARIOSHIELDS[SH_SHOE] = nil
	SH_SHOE = INT8_MIN
else
	--doubles as a script cancel if mario is not loaded
	return nil
end

--simple table to check characters compatible with mario powerups
isItABro = {
	mario = true,
	luigi = true
}
--another table to check which mario powerups or shields should have ring drain.
--key is the shield flag, value is the name of the shield in string form
ringDrainShields = {
	[SH_MINI] = "Mini Mushroom",
	[SH_BALLOON] = "P-Balloon"
}

end

--oh yeah define it now once the addon loads
defineKeyData()

--another function to handle the removal of the proper shield
local function removeShield(player, shieldCheck)
	--P_RemoveShield(player)
	--player.powers[pw_shield] = 0
	P_SwitchShield(player, SH_NONE)
	chatprintf(player, "You ran out of rings, no more " .. shieldCheck .. "...")
end

--mini mushroom has ring drain now
--also other powerups but too lazy to change name
local function ringDrainMini(player)

	--obligatory nil check
	if player.mo == nil then
		return
	--we don't care if player is a tagger or not a bro
	--(player.pflags & PF_TAGIT) or
	elseif isItABro[player.mo.skin] == nil then
		return
	end
	
	--Player is not nil, is a mario bro, and is IT.
	--The code will continue now assuming all the above.
	
	--Do the shield check now to save an instruction
	local shieldCheck = ringDrainShields[player.powers[pw_shield]]
	--player is both a hider and playing a mario bro, execute the code
	if shieldCheck == nil then
		--not using a ring drain enabled shield, return
		return
	end
	
	--remove mini mush if the ring count is zero
	if player.rings > 0 then
	--remove a ring and reset tics
		player.rings = $ - 1
	else
		--call the shield removal function
		removeShield(player, shieldCheck)
	end
end

--another function to handle the outside of ringDrainMini
local function preRingDrain(player)
--Check if ringdrain is enabled before running code
	if allowRingDrain.value == 1 then
		for player in players.iterate do
			ringDrainMini(player)
		end
	end
end

addHook("ThinkFrame", function(player)
	--check if the level time is on a ring drain frame.
	if leveltime % defaultMiniTics == 0 then
		preRingDrain(player)
	end
end)

--This bullshit stops resyncs, I don't know why, I fucking hate srb2 rn
addHook("PlayerJoin", defineKeyData)

print("Mario Bros Tweaks finished Loading.")