print("Momentum Rings Loading")

--==Functions==

local function speedCalc(ring, pmo) --mobj and player momentum
	--Get the speed we'll use, compare the player speed plus the modifier with the normal ring speed, use whatever is bigger.
	local player = pmo.player
	local RingSpeed = FixedHypot(player.rmomx, player.rmomy)
	--Set new momentum now
	local hangle,vangle = pmo.angle,player.aiming
	ring.momx = $ + FixedMul(RingSpeed,FixedMul(cos(hangle),cos(vangle)))
	ring.momy = $ + FixedMul(RingSpeed,FixedMul(sin(hangle),cos(vangle)))
	ring.momz = $ + FixedMul(RingSpeed,sin(vangle))
end

local function SpeedUpRing(ring)
	if ring.RunOnce == true
		return
	end
	local pmo = ring.target
	if pmo == nil
		return
	end
	ring.RunOnce = true
	
	speedCalc(ring, pmo)
end

local function FunnyGrenade(ring)
	if ring.RunOnce == true
		return
	end
	local pmo = ring.target
	if pmo == nil
		return
	end
	ring.RunOnce = true
	
	ring.momx = $ + pmo.momx
	ring.momy = $ + pmo.momy
	ring.momz = $ + pmo.momz
end

--==Hooks==

addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_REDRING)
addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_THROWNBOUNCE )
addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_THROWNINFINITY)
addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_THROWNAUTOMATIC)
addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_THROWNSCATTER)
addHook("MobjThinker", function(ring)
	SpeedUpRing(ring)
end, MT_THROWNEXPLOSION)
addHook("MobjThinker", function(ring)
	FunnyGrenade(ring)
end, MT_THROWNGRENADE)

--Add whisper stuff if she exists
--Commented out due to resync issues
--if skins["whisper"]
--	addHook("MobjThinker", function(ring)
--		SpeedUpRing(ring)
--	end, MT_WHISPER_LASER)
--	addHook("MobjThinker", function(ring)
--		SpeedUpRing(ring)
--	end, MT_WHISPER_ROCKET)
--end


print("Momentum Rings Finished Loading")