--this console variable holds the speed cap value
local maxGlobalSpeed = CV_RegisterVar({ --make a console variable to control whether intermission teamchange is blocked or not
	name = "tu_maxallowedspeed",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned
})

addHook("PostThinkFrame", function()
	for player in players.iterate do
		--don't run code if player mo is nil, or is speed cap is 0
		if player.mo == nil or maxGlobalSpeed.value < 1 or player.powers[pw_sneakers] then
			return
		elseif FixedHypot(player.mo.momx, player.mo.momy) > (maxGlobalSpeed.value * FRACUNIT) then
			player.mo.momx = cos(player.mo.angle) * maxGlobalSpeed.value
			player.mo.momy = sin(player.mo.angle) * maxGlobalSpeed.value
		end
	end
end)